ifndef __CLIB_INC
 include clib.inc
endif

.xlist

SEEK_CUR	equ 1
SEEK_END	equ 2
SEEK_SET	equ 0

ifdef __f__
_A_NORMAL	equ 80h
else
_A_NORMAL	equ 00h
endif
_A_RDONLY	equ 01h
_A_HIDDEN	equ 02h
_A_SYSTEM	equ 04h
_A_VOLID	equ 08h
_A_SUBDIR	equ 10h
_A_ARCH		equ 20h
ifdef __f__
_A_TEMPORARY	equ 0100h
_A_SPARSE_FILE	equ 0200h
_A_REPARSEPOINT equ 0400h
_A_COMPRESSED	equ 0800h
_A_OFFLINE	equ 1000h
_A_NOT_INDEXED	equ 2000h
_A_ENCRYPTED	equ 4000h
endif
_A_STDFILES	equ _A_ARCH or _A_RDONLY or _A_SYSTEM or _A_SUBDIR
_A_ALLFILES	equ _A_STDFILES or _A_HIDDEN

ifndef __f__

S_DISKFREE 	STRUC
df_size		dw ?
df_version	dw ?
df_sclus	dd ?
df_bsec		dd ?
df_avail	dd ?
df_total	dd ?
df_phavail	dd ?
df_phtotal	dd ?
df_alavail	dd ?
df_altotal	dd ?
df_reserved	db 8 dup(?)
S_DISKFREE 	ENDS

S_FFBLK		STRUC
ff_reserved	db 21 dup(?)
ff_attrib	db ?
ff_ftime	dw ?
ff_fdate	dw ?
ff_fsize	dd ?
ff_name		db 13 dup(?)
S_FFBLK		ENDS

ifdef __LFN__
externdef	_ifsmgr:byte
endif
externdef	_osversion:word
externdef	_osminor:byte
externdef	_osmajor:byte
externdef	_psp:word
externdef	envseg:word

findfirst	proto _CType :dword, :dword, :word
findnext	proto _CType :dword
beep		proto _CType :size_t, :size_t
endif ; __f__

externdef	_argc:size_t
externdef	_argv:dword

osmaperr	proto
externdef	errno:size_t
externdef	doserrno:size_t

S_FTIME		STRUC
ft_time		dw ?
ft_date		dw ?
ft_high		dd ?
S_FTIME		ENDS

S_WFBLK		STRUC
wf_attrib	dd ?		; DWORD File attributes
wf_timecreate	S_FTIME <>	; QWORD	File creation time
wf_timeaccess	S_FTIME <>	; QWORD	Last access time
wf_time		S_FTIME <>	; QWORD	Last modification time
wf_sizedx	dd ?		; QWORD	File size
wf_sizeax	dd ?		; - low DWORD
wf_reserved	db 8 dup(?)
wf_name		db 260 dup(?)
wf_shortname	db 14 dup(?)
S_WFBLK		ENDS	;  318 byte

delay		proto _CType :size_t
dosdate		proto _CType
dostime		proto _CType
getday		proto _CType
getsec		proto _CType
getmin		proto _CType
gethour		proto _CType
getmnd		proto _CType
getyear		proto _CType
getdatew	proto _CType

remove		proto _CType :dword
rename		proto _CType :dword, :dword

setftime	proto _CType :size_t, :ptr S_FTIME
_dos_setftime	proto _CType :size_t, :size_t, :size_t
; LFN + Win32
setftime_create	proto _CType :size_t, :ptr S_FTIME
_dos_setftime_create proto _CType :size_t, :size_t, :size_t
ifdef __f__
_dos_setftime_access proto _CType :size_t, :size_t, :size_t
setftime_access	proto _CType :size_t, :ptr S_FTIME
endif

getftime	proto _CType :size_t, :ptr S_FTIME
getftime_access	proto _CType :size_t, :ptr S_FTIME
getftime_create	proto _CType :size_t, :ptr S_FTIME
_dos_getftime	proto _CType :size_t, :dword, :dword
_dos_getftime_access proto _CType :size_t, :dword, :dword
_dos_getftime_create proto _CType :size_t, :dword, :dword

_dos_setfileattr proto _CType :dword, :size_t
_dos_getfileattr proto _CType :dword, :dword

getfattr	proto _CType :dword
filexist	proto _CType :dword
wfindfirst	proto _CType :dword, :dword, attrib:size_t
wfindnext	proto _CType :dword, :size_t
wcloseff	proto _CType :size_t

ifdef __LFN__
wsetfattr	proto _CType :DWORD, :WORD
wgetfattr	proto _CType :DWORD
wsetacdate	proto _CType :DWORD, :WORD
wsetwrdate	proto _CType :DWORD, :WORD, :WORD
wsetcrdate	proto _CType :DWORD, :WORD, :WORD
wgetacdate	proto _CType :DWORD
wgetwrdate	proto _CType :DWORD
wgetcrdate	proto _CType :DWORD
wfullpath	proto _CType :DWORD, :WORD
wvolinfo	proto _CType :ptr byte, :ptr byte
endif

wgetcwd		proto _CType :DWORD, :WORD
wlongname	proto _CType :DWORD, :DWORD
wlongpath	proto _CType :DWORD, :DWORD
wshortname	proto _CType :DWORD
removefile 	proto _CType :dword
removetemp	proto _CType :dword

ifdef __f__
exit		proto _CType :size_t
Beep		proto stdcall :size_t, :size_t
beep		equ <Beep>
FindFirstFileA	proto stdcall :dword, :dword
FindFirstFile	equ <FindFirstFileA>
FindNextFileA	proto stdcall :dword, :dword
FindNextFile	equ <FindNextFileA>
FindClose	proto stdcall :dword
GetFileAttributesA proto stdcall :dword
GetFileAttributes equ <GetFileAttributesA>
SetFileAttributesA proto stdcall :dword, :dword
SetFileAttributes equ <SetFileAttributesA>
GetFileTime	proto stdcall :dword, :dword, :dword, :dword
SetFileTime	proto stdcall :dword, :dword, :dword, :dword
DeleteFileA	proto stdcall :dword
DeleteFile	equ <DeleteFileA>
MoveFileA	proto stdcall :dword, :dword
MoveFile	equ <MoveFileA>
GetTickCount	proto stdcall
else
GetTickCount	proto _CType
endif

.list
